DECLARE FUNCTION PIOLesen% (Adresse%)
DECLARE SUB PIOschreiben (Adresse%, Ausgabewert%)
DEFINT A-Z
DECLARE SUB Resetanlegen ()

DIM SHARED PioA AS INTEGER
DIM SHARED PioB AS INTEGER
DIM SHARED PioC AS INTEGER
DIM SHARED PioCTRL AS INTEGER
DIM SHARED AdresseWK  AS INTEGER

Vorschlag = &H210: 'Adresse der BMC-Karte

CLS
PRINT " Testprogramm GROUPIE Modellbahnsteuerung"
PRINT
PRINT " berprfung einer Signalkarte"
PRINT " Bitte besttigen Sie die Adresse der PIO-Karte im PC "
PRINT " oder geben sie die richtige Adresse dezimal ein"
PRINT " Bei einer falschen Eingabe wird erneut gefragt."
PRINT
VIEW PRINT 8 TO 20
DO
    INPUT " Adresse PIO-Karte im PC (Vorschlag 528):", Adresse$
    IF LEN(Adresse$) = 0 THEN
        x = Vorschlag
    ELSE
        IF VAL(Adresse$) < 1000 THEN
            x = VAL(Adresse$)
        ELSE
            x = 1000
        END IF
    END IF
LOOP UNTIL x > 527 AND x < 797
VIEW PRINT 1 TO 25
CLS
PRINT " Testprogramm GROUPIE Modellbahnsteuerung"
PRINT
PRINT " berprfung einer Signalkarte"
PRINT
PRINT " Die Adresse der PIO-Karte lautet dezimal"; x
PRINT
PRINT " Bitte besttigen Sie die Adresse Ihrer Signalkarte"
PRINT " oder geben sie die richtige Adresse dezimal ein"
PRINT " Bei einer falschen Eingabe wird erneut gefragt."
VIEW PRINT 11 TO 20
Vorschlag = 128
DO
    INPUT " Adresse der Signalkarte (Vorschlag 128):", Adresse$
    AdresseNumerisch$ = ""
    FOR Zeichen = 1 TO LEN(Adresse$)
        IF INSTR("0123456789", MID$(Adresse$, Zeichen, 1)) THEN
            AdresseNumerisch$ = AdresseNumerisch$ + MID$(Adresse$, Zeichen, 1)
        END IF
    NEXT
    IF LEN(Adresse$) = 0 THEN
        AdresseWK = Vorschlag
    ELSE
        IF VAL(AdresseNumerisch$) < 256 AND VAL(AdresseNumerisch$) > -1 THEN
            AdresseWK = VAL(AdresseNumerisch$)
        ELSE
            AdresseWK = 1000
        END IF
    END IF
LOOP UNTIL AdresseWK > -1 AND AdresseWK < 256 AND AdresseWK MOD 2 = 0
VIEW PRINT 1 TO 25
CLS
PRINT " Testprogramm GROUPIE Modellbahnsteuerung"
PRINT
PRINT " berprfung einer Signalkarte"
PRINT " Die Adresse der PIO-Karte lautet dezimal"; x
PRINT " Adresse der Signalkarte ist"; AdresseWK

PioA = x: PioB = x + 1: PioC = x + 2: PioCTRL = x + 3
CALL Resetanlegen
CALL PIOschreiben(AdresseWK + 1, 0)
CALL PIOschreiben(AdresseWK, 0)

LOCATE 25, 1
PRINT " Enter-Taste => Ausgangssignal, Escape beendet das Programm";
LOCATE 10, 1
PRINT " Zustand der Ausgnge der Signalkarte"
PRINT
PRINT " 1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16";
Bit = -1
DO
    Aa$ = INKEY$
    IF Aa$ = CHR$(27) THEN
        Ende = -1
    END IF
    LOCATE 14, 1
    FOR Stelle = 0 TO 15
        IF Stelle = Bit THEN
            PRINT "   ";
        ELSE
            PRINT " 0  ";
        END IF
    NEXT Stelle
    PRINT
    IF Aa$ = CHR$(13) THEN
        Bit = Bit + 1
        IF Bit > 15 THEN
            Bit = 0
            CALL PIOschreiben(AdresseWK + 1, 0)
        END IF
        IF Bit > 7 THEN
            'PRINT 2 ^ (Bit - 8), AdresseWK + 1;
            CALL PIOschreiben(AdresseWK, 0)
            CALL PIOschreiben(AdresseWK + 1, 2 ^ (Bit - 8))
        ELSE
            'PRINT 2 ^ Bit, AdresseWK
            CALL PIOschreiben(AdresseWK, 2 ^ Bit)
        END IF
    END IF
LOOP UNTIL Ende
CALL Resetanlegen
CALL PIOschreiben(AdresseWK + 1, 0)
CALL PIOschreiben(AdresseWK, 0)

FUNCTION PIOLesen (Adresse)
    'diese funktion liest die unter der angegebenen adresse anliegenden daten
    'ndern des control-registers auf 'lesen von der steuerung'
    'lscht gleichzeitig alle ausgnge, d. h. c=0 erfolgt
    'automatisch, 4. bit gelscht, es kann von der steuerung gelesen werden
OUT PioCTRL, 152
    'die adresse, auf die geschrieben werden soll, wird angelegt
OUT PioB, Adresse
    'das signal 'Read' wird aktiviert
OUT PioC, 2
    'warteschleife von 100s in der Hardware, wird ber 5. bit abgefragt
    'die daten vom bus werden ber port A in 'lesen' geschrieben
'PioLesen = INP(PioA)
DO
    'zahl enthlt nur 0 oder 16 abhngig vom 5. bit
    Zahl = INP(PioC) AND 16
    Schleife = Schleife + 1
LOOP UNTIL Zahl OR Schleife > 10000
    'die daten vom bus werden ber port A in 'lesen' geschrieben
PIOLesen = INP(PioA)
IF Schleife > 10000 THEN
    CLS
    PRINT "Die Interfacekarte ist nicht in Ordnung, kein Betrieb mglich!!!"
    BEEP
    END
END IF
      'control-register wieder auf schreiben umstellen, folglich wieder C=0
OUT PioCTRL, 136
    '4. bit wird gesetzt, d. h. richtung 'schreiben'
OUT PioC, 8
END FUNCTION

SUB PIOschreiben (Adresse, Ausgabewert)
     'IF Ausgabewert <> 0 THEN
     'PRINT #2, TIMER, Adresse, Ausgabewert
     'Die Adresse wird angelegt
OUT PioB, Adresse
    'der ausgabewert wird angelegt
OUT PioA, Ausgabewert
    '3. und 4. bit wird gesetzt, d. h. richtung= schreiben + 'write' aktiv
OUT PioC, 12
    'nur noch 4. bit fr richtung = schreiben gesetzt
    'STOP
DO
        'zahl enthlt nur 0 oder 16 abhngig vom 5. bit
    Zahl = INP(PioC) AND 16
    Schleife = Schleife + 1
LOOP UNTIL Zahl OR Schleife > 10000
OUT PioC, 8
IF Schleife > 10000 THEN
    CLS
    PRINT "Die Interfacekarte ist nicht in Ordnung, kein Betrieb mglich!!!"
    BEEP
    END
END IF
END SUB

SUB Resetanlegen
'   control-register auf schreiben setzen
OUT PioCTRL, 136
    '1. bit fr 'reset' wird gesetzt
OUT PioC, 1
    'pause 1 sekunde
SLEEP 1
    '4. bit fr richtung = schreiben wird gesetzt, der rest gelscht
OUT PioC, 8
END SUB

